#!/bin/sh
fromearly=false
fromdevelop=false
domerge=false

. ./build-env.sh

lxmmmkb=`echo ${lxdebkb} | cut -d '.' -f 1-2`

if [ ! -e linux-rockchip-4.4.y ]; then
  #git clone -b rockpro64-4.4.y --depth 1 https://github.com/hardkernel/linux linux-rockchip-4.4.y
  #git clone -b develop-4.4 --depth 1000 https://github.com/rockchip-linux/kernel linux-rockchip-4.4.y
  #git clone -b rockpro64-4.4.y --depth 1 https://github.com/Owersun/linux-hardkernel linux-rockchip-4.4.y
  #git clone -b release-4.4.202 --depth 1 https://github.com/ayufan-rock64/linux-kernel linux-rockchip-4.4.y
  #git clone -b rocksbc-4.4.y --depth 1 https://github.com/scpcom/linux-ayufan-4.4.y linux-rockchip-4.4.y
  #git clone -b develop-4.4 https://github.com/scpcom/linux-ayufan-4.4.y linux-rockchip-4.4.y
  git clone -b develop-4.4 https://github.com/scpcom/linux-rockchip-4.4.y linux-rockchip-4.4.y
  
  cd linux-rockchip-4.4.y

  if false; then
  #git checkout 4b2de01e0c484e8a2567699866190d793f374b12
  git checkout 90e91f988b9badf5e64100cec667acc434af1718
  git checkout -b rocksbc-4.4.y

  git checkout mainline-4.4
  git checkout c4f11a973295ba9ecfe1881ede91025b59d43916
  git checkout -b mainline-4.4.218
  fi

  #git checkout develop-4.4
  git checkout rocksbc-4.4.y

  cd ..
fi

echo "Copying files from linux-${lxmmmkb}.y git..."
mkdir linux && \
cp -apP linux-rockchip-4.4.y/. linux/

cd linux

if $fromdevelop ; then
git checkout develop-4.4
git checkout 90e91f988b9badf5e64100cec667acc434af1718
git checkout -b rocktest-4.4.y
fi

VERSION=`cat Makefile | grep -E '^VERSION.=' | cut -d "=" -f 2- | tr -d " \t\n\r"`
PATCHLEVEL=`cat Makefile | grep PATCHLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`
SUBVERSION=`cat Makefile | grep SUBLEVEL.= | cut -d "=" -f 2- | tr -d " \t\n\r"`

quiltpatches() {
  if [ -e ../patches/$2 ]; then
    mkdir -p patches/$1

    for p in `cat ../patches/$2 | grep -v '^#' | grep patch` ; do
      b=`basename $p`

      if [ -e ../patches/${p} ]; then
        cp -p ../patches/${p} patches/${p}
      else
        cp -p  ../patches/${b} patches/${p}
      fi
    done

    cat ../patches/$2 >> patches/series

    quilt push -a
  fi

}

simplepatch() {
  p=$1
  f=$2

  b=`basename $p`
  d=`dirname $p`
  l=${p}
  n=`echo $b | sed s/\.patch$//g`

  mkdir -p patches/${d}
  cp -p ../patches/${p} patches/${d}/
  git apply patches/${p}
  git add ${f}
  git commit -m "${d} ${n}"
  echo "${p}" >> patches/series
}

gitpatches() {
  if [ -e ../patches/$2 ]; then
    echo ""
    echo "Apply series patches/$2"
    echo ""

    mkdir -p patches/$1

    l=none
    for p in `cat ../patches/$2 | grep -v '^#' | grep patch` ; do
      b=`basename $p`
      d=`dirname $p`
      l=${p}
      n=`echo $b | sed s/\.patch$//g`

      if [ -e ../patches/${p} ]; then
        cp -p ../patches/${p} patches/${p}
      else
        cp -p  ../patches/${b} patches/${p}
      fi

      echo "Apply patch patches/${p}"

      #if grep -q '\\r' patches/${p} ; then
      #  sed -i -e 's/\r$//g' patches/${p}
      #fi

      nogitcp=1
      gitcpcont=0
      nogitam=1
      gitamcont=0
      if false ; then
      if grep -m1 -q "^From ${n} Mon Sep 17 00:00:00 2001" patches/${p} ; then
        rc=0
        git cherry-pick ${n} || rc=$?
        echo "git cherry-pick ${n}: rc=${rc}"
        if [ $rc = 0 ] ; then
          nogitcp=0
          echo ${p} >> patches/series-cherry-pick
        elif [ $rc != 128 ] ; then
          #gitcpcont=1
          git cherry-pick --abort
        fi
      fi
      fi

      if [ $nogitcp = 1 -a $gitcpcont = 0 ]; then
      if grep -m1 -q "^From ........................................ Mon Sep 17 00:00:00 2001" patches/${p} ; then
        c=`grep -m1 "^From ........................................ Mon Sep 17 00:00:00 2001" patches/${p} | sed s/'^From '//g | cut -d ' ' -f1`

        sed -i -e "0,/^---$/ s/^---$/\n${d} ${c}\n---/" patches/${p}

        if git am --keep-cr < patches/${p} ; then
          nogitam=0
          echo ${p} >> patches/series-am
        else
          gitamcont=1
          #git am --skip
        fi
      fi
      fi

      if [ $nogitam = 1 -a $nogitcp = 1 ]; then
        pb=`echo ${p} | sed s/'\.patch$'/'-bin.patch'/g`

        #echo "Check patches/${pb}"
        if [ -e ../patches/${pb} ]; then
          cp -p ../patches/${pb} patches/${pb}
          echo git apply --stat --apply patches/${pb}
          git apply --stat --apply patches/${pb}
        fi

        if ! git apply --stat --apply patches/${p} ; then
          #git apply --stat --apply --3way patches/${p}
          #sed -i -e 's/\r$//g' patches/${p}
          patch -p1 --no-backup-if-mismatch < patches/${p}
          echo ${p} >> patches/series-no-git
        else
          echo ${p} >> patches/series-no-am
        fi
      fi

      if echo $n | grep -q -E '^linux-' ; then
        n=`echo $n | sed s/^linux-4\.4\.y-//g`

      elif grep -m1 -q "^From ${n} Mon Sep 17 00:00:00 2001" patches/${p} ; then
        if ! grep -q '^---$' patches/${p} ; then
          exit 1
        fi

      else
        exit 1
      fi

      if [ $nogitam = 1 -a $nogitcp = 1 ]; then
        echo git commit -m "${d} ${n}"
        git add .
        #git commit -m "${d} ${n}"
        #echo "${d} ${n}" > patches/${p}.msg

        if grep -m1 -q "^From ........................................ Mon Sep 17 00:00:00 2001" patches/${p} ; then
          if ! grep -q '^---$' patches/${p} ; then
            exit 1
          fi
          cat patches/${p} | grep -m1 -B399 '^---$' | sed /^---$/d | grep -m1 -A399 '^Subject:' | sed s/'^Subject: '/''/g > patches/${p}.msg
        else
          echo "${d} ${n}" > patches/${p}.msg
        fi
        
        if [ $gitcpcont = 1 ]; then
          git cherry-pick --continue
        elif [ $gitamcont = 1 ]; then
          git am --continue
        else
          git commit -F patches/${p}.msg
        fi
      fi

      echo ""
    done

    echo "Now in patch patches/${l}"
    cat ../patches/$2 >> patches/series

    #quilt push -a
  fi

}

applypatches() {
  gitpatches $1 $2
  #quiltpatches $1 $2
}

gitmerge() {
  mname=$1
  mbranch=$2

  start_range=`git rev-list --simplify-by-decoration -2 HEAD`

  start_range_0=`echo $start_range | cut -d ' ' -f 1`
  start_range_1=`echo $start_range | cut -d ' ' -f 2`

  git merge -s recursive -X ours -X renormalize -X no-renames origin/${mbranch} | tee ../merge-${mname}.log

  commit_range=`git rev-list --simplify-by-decoration -2 HEAD`

  commit_range_0=`echo $commit_range | cut -d ' ' -f 1`
  commit_range_1=$start_range_0

  git log --decorate=no --reverse ${commit_range_1}..${commit_range_0} | grep -E '^commit ' | cut -d ' ' -f 2- > ../merge-${mname}-commit-list.txt

  cm=`cat ../merge-${mname}-commit-list.txt | tail -1`

  for c in `cat ../merge-${mname}-commit-list.txt` ; do
    if [ ${c} != ${cm} ] ; then
      echo "${mname}/${c}.patch" >> patches/series-${mname}-merge
    fi
    if [ ${mname} = mainline ]; then
      grep ${c} ../patches/series-${mname}-??? | cut -d ':' -f 2- >> patches/series-${mname}-quilt
    else
      grep ${c} ../patches/series-${mname}-20?????? | cut -d ':' -f 2- >> patches/series-${mname}-quilt
    fi
  done

  cat patches/series-${mname}-merge >> patches/series-merge
  cat patches/series-${mname}-merge >> patches/series
}

#mkdir -p patches/platform

#cp -apP ../patches/. patches/platform/
#cat ../patches/series-platform >> patches/series
#quilt push -a

mkdir -p patches/mainline
mkdir -p patches/owersun

if $fromdevelop ; then
applypatches platform series-platform

applypatches rockchip series-rockchip
if $fromearly ; then
applypatches rockchip series-fscrypt
applypatches rockchip series-media-rc
applypatches rockchip series-zram

applypatches rockchip series-rockchip-20190125
applypatches rockchip series-rockchip-20190220
applypatches rockchip series-rockchip-20190516
applypatches rockchip series-rockchip-20190617
applypatches rockchip series-rockchip-20190628
applypatches rockchip series-rockchip-20190927
applypatches rockchip series-rockchip-20191029
applypatches rockchip series-rockchip-20200120
applypatches rockchip series-rockchip-20200316
fi
applypatches rockchip series-rockchip-99991231

applypatches ayufan series-ayufan
applypatches hardkernel series-hardkernel
applypatches owersun series-owersun

applypatches radxa series-radxa
fi

if [ -e ../patches/mainline ]; then
  #mv patches/platform/mainline patches/
  for s in `ls ../patches/series-mainline-???` ; do
    b=`basename $s`
    v=`basename $s | cut -d '-' -f 3`
    if [ $SUBVERSION -lt $v ]; then
      echo ""
      if [ -e ../patches/${b}-prepare ]; then
        applypatches mainline ${b}-prepare
      fi
      #applypatches mainline ${b}
      #echo ""
      #echo "" >> patches/series
      #cat $s >> patches/series
      #quilt push -a
    fi
  done
fi

if $domerge ; then
# b63f449e18b130fdc372b9717e72c19b83fc4876 Linux 4.4.222
gitmerge mainline mainline-4.4
fi

if [ -e ../patches/mainline ]; then
  #mv patches/platform/mainline patches/
  for s in `ls ../patches/series-mainline-???` ; do
    b=`basename $s`
    v=`basename $s | cut -d '-' -f 3`
    if [ $SUBVERSION -lt $v ]; then
      echo ""
      if [ -e ../patches/${b}-post ]; then
        applypatches mainline ${b}-post
      fi
      #echo ""
      #echo "" >> patches/series
      #cat $s >> patches/series
      #quilt push -a
    fi
  done
fi

if $fromearly ; then
# binary patches
gitpatches rockchip series-binary

#git apply patches/rockchip/0550094bdb94e316c5f0b64b84a428c9f55f8cb0.patch
#git apply patches/rockchip/9579567b7dbcc961a670ed6a9463b2b4bd60ceac.patch
fi

if $fromdevelop ; then
applypatches hardkernel series-hardkernel-odroidgoa
applypatches friendlyarm series-friendlyarm 
applypatches firefly series-firefly
applypatches firefly series-fireflypro
applypatches orangepi series-orangepi
applypatches leez series-leez

mkdir -p patches/friendlyarm
mkdir -p patches/firefly
applypatches orangepi series-logos

applypatches khadas series-khadas
applypatches platform series-camera

# c4af28d0af7a78e89c37ecfc37ed44c8cc59ee05 Apr 26, 2020
gitmerge rockchip develop-4.4
fi

pcount=0
if [ -e patches/series ]; then
  pcount=`cat patches/series | grep -v -E '^#' | grep patch | wc -l`

  mv patches/series patches/series-git
fi

echo ""

if [ -e patches/series-no-am -a -e patches/series-no-git -a -e patches/series-am -a -e patches/series-merge ]; then
  gcount=`cat patches/series-merge | grep -v -E '^#' | grep patch | wc -l`
  mcount=`cat patches/series-am | grep -v -E '^#' | grep patch | wc -l`
  acount=`cat patches/series-no-am  | grep -v -E '^#' | grep patch | wc -l`
  ncount=`cat patches/series-no-git | grep -v -E '^#' | grep patch | wc -l`
  echo "Applied ${pcount} patches (${gcount} with git merge, ${mcount} with git am, ${acount} with git apply, ${ncount} outside git)."

elif [ -e patches/series-no-am -a -e patches/series-no-git -a -e patches/series-am ]; then
  mcount=`cat patches/series-am | grep -v -E '^#' | grep patch | wc -l`
  acount=`cat patches/series-no-am  | grep -v -E '^#' | grep patch | wc -l`
  ncount=`cat patches/series-no-git | grep -v -E '^#' | grep patch | wc -l`
  echo "Applied ${pcount} patches (${mcount} with git am, ${acount} with git apply, ${ncount} outside git)."

elif [ -e patches/series-no-am -a -e patches/series-no-git -a -e patches/series-cherry-pick ]; then
  ccount=`cat patches/series-cherry-pick | grep -v -E '^#' | grep patch | wc -l`
  acount=`cat patches/series-no-am  | grep -v -E '^#' | grep patch | wc -l`
  ncount=`cat patches/series-no-git | grep -v -E '^#' | grep patch | wc -l`
  echo "Applied ${pcount} patches (${ccount} cherry-picked, ${acount} with git apply, ${ncount} outside git)."

elif [ -e patches/series-no-am -a -e patches/series-no-git ]; then
  acount=`cat patches/series-no-am  | grep -v -E '^#' | grep patch | wc -l`
  ncount=`cat patches/series-no-git | grep -v -E '^#' | grep patch | wc -l`
  echo "Applied ${pcount} patches (${acount} with git apply, ${ncount} outside git)."

elif [ -e patches/series-no-git ]; then
  ncount=`cat patches/series-no-git | grep -v -E '^#' | grep patch | wc -l`
  echo "Applied ${pcount} patches (${ncount} outside git)."

else
  echo "Applied ${pcount} patches."
fi

echo ""

if $fromdevelop ; then
patch -p1 < ../patches/linux-4.4.y-rk-debpkg-no-dts.patch

git add scripts/package/builddeb
git commit -m "rk-debpkg-no-dts"
fi

if false; then
for f in ../patches/*_defconfig ; do
  c=`basename $f`
  c=${c/_defconfig/}

  if grep -q '^CONFIG_ARM64=y' $f ; then
    #if [ -e arch/arm64/configs/${c}_defconfig ]; then
    # mv arch/arm64/configs/${c}_defconfig arch/arm64/configs/${c}_git_defconfig
    #fi
    cp -p $f arch/arm64/configs/
  fi
done

#LANG=C git diff arch/arm64/configs
git add arch/arm64/configs
git commit -m "arm64: configs: update rk33 defconfigs"
fi

if false; then
for f in ../patches/*_defconfig ; do
  c=`basename $f`
  c=${c/_defconfig/}

  if grep -q '^CONFIG_ARM_.*=y' $f ; then
  if ! grep -q '^CONFIG_ARM64=y' $f ; then
    #if [ -e arch/arm/configs/${c}_defconfig ]; then
    # mv arch/arm/configs/${c}_defconfig arch/arm/configs/${c}_git_defconfig
    #fi
    cp -p $f arch/arm/configs/
  fi
  fi
done

git add arch/arm/configs
git commit -m "arm: configs: update rk32 defconfigs"
fi

if false; then
for f in ../patches/*_ubuntu_defconfig ; do
  c=`basename $f`
  c=${c/_defconfig/}

  if grep -q '^CONFIG_X86_.*=y' $f ; then
    #if [ -e arch/x86/configs/${c}_defconfig ]; then
    # mv arch/x86/configs/${c}_defconfig arch/x86/configs/${c}_git_defconfig
    #fi
    cp -p $f arch/x86/configs/
  fi
done

git add arch/x86/configs
git commit -m "x86: configs: update ubuntu defconfigs"
fi

tar xzf ../linux-4.4.y-*-firmware-edid.tar.gz

echo OK
